﻿Public Class EnteFiscal

    Private m_nombre As String = "CONSUMIDOR FINAL"
    Private m_documento As String = "0"
    Private m_tipoDocumento As ControladorFiscal.TiposDeDocumento = ControladorFiscal.TiposDeDocumento.TIPO_NINGUNO
    Private m_responsabilidadIVA As ControladorFiscal.TiposDeResponsabilidades = ControladorFiscal.TiposDeResponsabilidades.CONSUMIDOR_FINAL
    Private m_domiclio As String = String.Empty

    Public Property Nombre() As String
        Get
            Return m_nombre
        End Get
        Set(ByVal value As String)
            m_nombre = value
        End Set
    End Property
    Public Property Documento() As String
        Get
            Return m_documento
        End Get
        Set(ByVal value As String)
            m_documento = value
        End Set
    End Property
    Public Property TipoDocumento() As ControladorFiscal.TiposDeDocumento
        Get
            Return m_tipoDocumento
        End Get
        Set(ByVal value As ControladorFiscal.TiposDeDocumento)
            m_tipoDocumento = value
        End Set
    End Property
    Public Property ResponsabilidadIVA() As ControladorFiscal.TiposDeResponsabilidades
        Get
            Return m_responsabilidadIVA
        End Get
        Set(ByVal value As ControladorFiscal.TiposDeResponsabilidades)
            m_responsabilidadIVA = value
        End Set
    End Property
    Public Property Domicilio() As String
        Get
            Return m_domiclio
        End Get
        Set(ByVal value As String)
            m_domiclio = value
        End Set
    End Property

    Public Sub New()

    End Sub

    Public Sub New(ByVal Nombre As String, _
                   ByVal Documento As String, _
                   ByVal TipoDocumento As ControladorFiscal.TiposDeDocumento, _
                   ByVal ResponsabilidadIVA As ControladorFiscal.TiposDeResponsabilidades, _
                   ByVal Domicilio As String)
        m_documento = Documento
        m_domiclio = Domicilio
        m_nombre = Nombre
        m_responsabilidadIVA = ResponsabilidadIVA
        m_tipoDocumento = TipoDocumento
    End Sub

    Public Function ToFields() As Collection
        Dim f As Collection = New Collection
        f.Add(New CampoFiscal(MyClass.Nombre))
        f.Add(New CampoFiscal(MyClass.Documento))
        f.Add(New CampoFiscal(MyClass.ResponsabilidadIVA, CampoFiscal.FormatosCampoFiscal.ASCII_TO_CHAR))
        f.Add(New CampoFiscal(MyClass.TipoDocumento, CampoFiscal.FormatosCampoFiscal.ASCII_TO_CHAR))
        f.Add(New CampoFiscal(MyClass.Domicilio))
        Return f
    End Function

End Class
