﻿Imports LibreriaFiscal
Imports LibreriaFiscal.ControladorFiscal

Public Class EpsonTipoDeDocumento

    Private Shared m_tipos As Collection = Nothing

    Public Shared ReadOnly Property Tipo(ByVal Index As TiposDeDocumento) As String
        Get
            If m_tipos Is Nothing Then m_tipos = Load()
            Return m_tipos(Index.ToString)
        End Get
    End Property

    Private Shared Function Load() As Collection
        Dim t As Collection = New Collection
        Dim items As Array = System.Enum.GetValues(GetType(TiposDeDocumento))
        For Each item As TiposDeDocumento In items
            Select Case item
                Case TiposDeDocumento.TIPO_CUIL : t.Add("CUIL", item.ToString)
                Case TiposDeDocumento.TIPO_CUIT : t.Add("CUIT", item.ToString)
                Case TiposDeDocumento.TIPO_DNI : t.Add("DNI", item.ToString)
                Case Else : t.Add("error!", item.ToString)
            End Select
        Next
        Return t
    End Function


End Class
