﻿Public Class ExcepcionFiscal : Inherits Exception

    Public Enum ExcepcionesFiscales
        A_IMPLEMENTAR
        A_TRATAR_EN_APLICATIVO_CLIENTE
        PUERTO_INVALIDO
        PUERTO_NO_DISPONIBLE
        COMANDO_INVALIDO
        COMANDO_DESCONOCIDO
        SIN_CONTACTO_CON_EL_PRINTER

    End Enum

    Public Sub New()
        MyBase.New()
    End Sub

    Public Sub New(ByVal Excepcion As ExcepcionesFiscales)
        MyBase.New(Excepcion.ToString)
    End Sub

    Public Sub New(ByVal Excepcion As ExcepcionesFiscales, ByVal Origen As Exception)
        MyBase.New(Excepcion.ToString, Origen)
    End Sub

    Public Sub New(ByVal Mensaje As String)
        MyBase.New(Mensaje)
    End Sub

    Public Sub New(ByVal Mensaje As String, ByVal Origen As Exception)
        MyBase.New(Mensaje, Origen)
    End Sub

End Class
