﻿Imports System.Timers

Public Class FiscalTimer : Inherits Timer

    Private m_isExausted As Boolean = False

    ReadOnly Property IsExausted() As Boolean
        Get
            Return m_isExausted
        End Get
    End Property

    Sub New()
        MyBase.New()
    End Sub

    Sub New(ByVal Interval As Double)
        MyBase.New(Interval)
    End Sub

    Sub Reset()
        MyBase.Stop() : m_isExausted = False : MyBase.Start()
    End Sub

    Sub Reset(ByVal Interval As Double)
        MyBase.Stop()
        MyBase.Interval = Interval : m_isExausted = False : MyBase.Start()
    End Sub

    Private Sub FiscalTimer_Elapsed(ByVal sender As Object, ByVal e As System.Timers.ElapsedEventArgs) Handles Me.Elapsed
        m_isExausted = True : MyBase.Stop()
    End Sub
End Class
